'  =======================================================================================
'  ELKit32PB.INC
'  -------------
'
'  Version  1.0.0 - 27-June-2003
'
'  Copyright (C) 2003  Roger D. Rines
'
'  emailto:rdrines@spamcop.net?Subject[PB-Bones]
'  =============================================================================
'   
'   This library is free software; you can redistribute it and/or
'   modify it under the terms of the GNU Lesser General Public
'   License as published by the Free Software Foundation; either
'   version 2.1 of the License, or (at your option) any later version.
'   
'   This library is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'   Lesser General Public License for more details.
'   
'   You can read the full GPL Lesser General Public License here:
'   http://www.gnu.org/copyleft/lesser.html
'   
'   Or, you should have received a copy of the GNU Lesser General Public
'   License along with this library; if neither happen, you can write to 
'   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
'   Boston, MA  02111-1307  USA
'  
'  USE:
'  =======================================================================================
'  
'  This INCLUDE file is a "C" header conversion to PowerBASIC.  Include this file in any
'  DLL source code if you intended to work with Easy Language to access the exposed 
'  Functions contained in the ELKit32.DLL.
'
'  As the author of this file, any use of this information is allowed as long as it 
'  isn't sold as a source file.

'  All Functions listed have been tested with TradeStation 2000i (Versions 5), 
'  TradeStation version 6 and TradeStation version 7.02 (current release).
'  
'  Place this file in your PowerBASIC DLL code list just below the Win32API.INC file if you
'  need to use the ELKit32.DLL functions in your DLL.
'
'  Once your DLL has been compiled, it should be placed in a directory where TradeStation can
'  find it.  This is usually in the same directory as "\Program Files\Omega Research\Program\"
'  If you place your DLL file in any other location, you will need to add the path to the 
'  Declaration statements listed at the top of your Easy Language program.
'  
'  EXAMPLE:
'    DefineDLLFunc: "PB-Bones.DLL", FLOAT, "MinutesToTime", FLOAT ;         { Program Directory }
'    DefineDLLFunc: "C:\Temp\PB-Bones.DLL", FLOAT, "MinutesToTime", FLOAT ; { Temp Directory    }
'
'  ELKit32.DLL Function Information:   
'  =======================================================================================
'  FUNCTIONS:
'      FindAddress_Open          
'      FindAddress_High
'      FindAddress_Low  
'      FindAddress_Close    
'      FindAddress_Volume
'      FindAddress_OpenInt
'      FindAddress_UpTicks
'      FindAddress_DownTicks
'      FindAddress_Date
'      FindAddress_Time
'      FindAddress_Var
'      FindAddress_Array
'
'  All above FUNCTIONS return a 32-bit address for the named data object listed in the FUNCTION's
'  name-suffix.  All FUNCTIONS require the address of one data object and an OffSet value.
'  OffSet values that are positive, move back in time, and negative OffSets move forward.
'  Data object request should not use OffSet values that are later than the CurrentBar
'  value and shouldn't attempted access that are earlier than the MaxBarsBack value
'  currently set in the attached Easy Language program. 
'  
'  If keeping the number of DLL_ADD and DLL_FREE calls the same, don't use the AutoDetect
'  option made available for determining the correct number of MaxBarsBack.
'
'  DECLARATIONS:
'  =======================================================================================

'  Locate the address of the OPEN price field value
DECLARE FUNCTION FindAddress_Open LIB "ELKit32.DLL" ALIAS "FindAddress_Open"_   
                                    (BYVAL lpOpen AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the HIGH price field value  
DECLARE FUNCTION FindAddress_High LIB "ELKit32.DLL" ALIAS "FindAddress_High"_  
                                    (BYVAL lpHigh AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the LOW price field value	   
DECLARE FUNCTION FindAddress_Low LIB "ELKit32.DLL" ALIAS "FindAddress_Low"_ 
                                    (BYVAL lpLow AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the CLOSE price field value  
DECLARE FUNCTION FindAddress_Close LIB "ELKit32.DLL" ALIAS "FindAddress_Close"_
                                     (BYVAL lpClose AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the VOLUME field value
DECLARE FUNCTION FindAddress_Volume LIB "ELKit32.DLL" ALIAS "FindAddress_Volume"_ 
                                       (BYVAL lpVolume AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the OPEN INTEREST field value
DECLARE FUNCTION FindAddress_OpenInt LIB "ELKit32.DLL" ALIAS "FindAddress_OpenInt"_
                                       (BYVAL lpOpenInt AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the UpTicks field value - Intraday data  
DECLARE FUNCTION FindAddress_UpTicks LIB "ELKit32.DLL" ALIAS "FindAddress_UpTicks"_
                                       (BYVAL lpUpTicks AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the DownTicks field value -  Intraday data
DECLARE FUNCTION FindAddress_DownTicks  LIB "ELKit32.DLL" ALIAS "FindAddress_DownTicks"_
                                 (BYVAL lpDownTicks AS DWORD, BYVAL nOfs AS LONG) AS LONG

'  Locate the address of the Date field value
DECLARE FUNCTION FindAddress_Date LIB "ELKit32.DLL" ALIAS "FindAddress_Date"_
                                  (BYVAL lpDate AS DWORD, BYVAL nOfs AS LONG) AS DWORD

'  Locate the address of the Time field value 
DECLARE FUNCTION FindAddress_Time LIB "ELKit32.DLL" ALIAS "FindAddress_Time"_
                                 (BYVAL lpTime AS DWORD, BYVAL nOfs AS LONG) AS DWORD
                                   
'  Locate the address of a Series Variable
DECLARE FUNCTION  FindAddress_Var LIB "ELKit32.DLL" ALIAS "FindAddress_Var"_
                    (BYVAL lpVar AS DWORD, BYVAL nOfs AS LONG,_
                     BYVAL wStartAddr AS DWORD,_
                     BYVAL wVarSize AS DWORD) AS DWORD

'  Locate the address or Array Element
DECLARE FUNCTION FindAddress_Array LIB "ELKit32.DLL" ALIAS "FindAddress_Array"_
                      (BYVAL lpArray AS DWORD,_
                       BYVAL nSpaceOfs AS LONG,_
                       BYVAL nTimeOfs AS LONG,_
                       BYVAL wStartAddr AS DWORD,_
                       BYVAL wArraySize AS DWORD) AS DWORD


'  =======================================================================================
'   These FUNCTIONS are inherent in Easy Language and are NOT called outside of the DLL
'  =======================================================================================
                       
'  Accepts a Easy Language Julian Date value and returns an Easy Language Date
DECLARE FUNCTION JulianToDate LIB "ELKit32.DLL" ALIAS "JulianToDate" (BYVAL jDay AS WORD) AS DWORD

'  Accepts an Easy Language Date value and returns an Easy Language Julian Day value
DECLARE FUNCTION DateToJulian LIB "ELKit32.DLL" ALIAS "DateToJulian" (BYVAL cDate AS DWORD) AS WORD

'  =======================================================================================
'                             ELKit32PB.INC file END
'  =======================================================================================
