'  aSimple.BAS
'  -----------

'  Written by: Roger D. Rines
'  Date:       7-July-2003
'  Purpose:    Minimal DLL Source Code Example 
'        
'  ===========================================================================
   #DIM ALL                         '  Forces ALL Variables to be DECLARED
   
   #COMPILE DLL "aSimple.DLL"       '  Prefix part can be almost any name you like
   #INCLUDE "PB-Bones.INC"          '  Uses minimum required declarations in place
                                    '  of entire WIN32API.INC file.
'   #INCLUDE "ELKit32PB.INC"        '  Not used in this simple example                            

'  ===========================================================================
   DECLARE FUNCTION DoubleIt (BYVAL AnyPrice AS SINGLE) AS SINGLE

'  ===========================================================================

'  ------------------------------------
'  Simple example of how a direct call can be made from EL
'  Passing the actual price value instead using the address
'  of the price object to locate the value of the variable
FUNCTION DoubleIt (BYVAL AnyPrice AS SINGLE) EXPORT AS SINGLE

   FUNCTION = AnyPrice * 2                            ' Double the Price
END FUNCTION   '  DoubleIt 

   
   
'  =============================================================================
'  LIBMAIN is always called when it is attached to another program.  When the first
'  Easy Language program sends the '%DLL_PROCESS_ATTACH' call, the processing and 
'  communication environment is established and '%DLL_PROCESS_ATTACH' is not called 
'  again until it has been released by all processes accessing the DLL.  This means,
'  that as long as any Easy Language program is using the '%DLL_THREAD_DETACH' 
'  signal will not be sent.
'
FUNCTION LIBMAIN(BYVAL hInstance AS DWORD,_
                 BYVAL Reason    AS LONG,_
                 BYVAL Reserved  AS LONG) AS LONG
      
   SELECT CASE Reason
      CASE %DLL_PROCESS_ATTACH
         '   initialize DLL here with whatever you need initialized
         
         LIBMAIN = 1
         EXIT FUNCTION                                   '  LIBMAIN

      CASE %DLL_PROCESS_DETACH
         '   This is where app unloads the DLL

         EXIT FUNCTION                                   '  LIBMAIN
   
      CASE %DLL_THREAD_ATTACH
         '   This is like %DLL_PROCESS_ATTACH 
         
         EXIT FUNCTION                                   '  LIBMAIN
   
      CASE %DLL_THREAD_DETACH                                
         '   This is like %DLL_PROCESS_DETACH
         
         EXIT FUNCTION                                   '  LIBMAIN
      
      END SELECT  '  CASE Reason
   
   ' If you get here, you are in serious trouble
   MSGBOX "Windows Error in PB-Dones.DLL - LIBMAIN() - Reboot Windows"
   
   '   A Serious Failure has Occured!
   LIBMAIN = 0  
END FUNCTION   '  LIBMAIN

'  =============================================================================
'                       END OF DLL SOURCE CODE
'  =============================================================================
'

'  =============================================================================
'                       START OF Easy Language SOURCE CODE
'  =============================================================================
'  
'   DefineDLLFunc: "C:\Z\TS-DLL\PB-Bones.dll", FLOAT, "DoubleIt", FLOAT ;
'
'
'  { Test a FUNCTION DoubleIt }
'  Value1 = DoubleIt( CLOSE );             { CALL the DLL FUNCTION }
'
'  { Display Results }
'  PRINT("Original Value =", CLOSE:8:4, "  Doubled Value =", Value1:8:4);
'
'  =============================================================================
'                       START OF Easy Language SOURCE CODE
'  =============================================================================
