'  =============================================================================
'  PB-DebugLog.INC                    TradeStation PowerBASIC DLL Template
'  ---------------
'  Version  1.0.0 - 27-June-2003
'
'  Copyright (C) 2003  Roger D. Rines
'
'  emailto:rdrines@spamcop.net?Subject[PB-Bones]
'  =============================================================================
'   
'   This library is free software; you can redistribute it and/or
'   modify it under the terms of the GNU Lesser General Public
'   License as published by the Free Software Foundation; either
'   version 2.1 of the License, or (at your option) any later version.
'   
'   This library is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'   Lesser General Public License for more details.
'   
'   You can read the full GPL Lesser General Public License here:
'   http://www.gnu.org/copyleft/lesser.html
'   
'   Or, you should have received a copy of the GNU Lesser General Public
'   License along with this library; if neither happen, you can write to 
'   the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
'   Boston, MA  02111-1307  USA
'   
'  USE:
'  =============================================================================
'  
'  This source file is a PowerBASIC model that is compatible with Omega's 
'  TradeStation software.  This code must be used with the PB-Bones.BAS file.
'  =============================================================================
DECLARE FUNCTION StartLog%(LogFile$)            '  Starts the Log file        - Debug
Declare Sub WriteLog( LogRecord$)               '  Writes to the Log file     - Debug
DECLARE SUB EndLog                              '  Closes the log file        - Debug                                                                    

'  =============================================================================
'  GLOBAL VARIABLE DEFINITIONS
'  =============================================================================

%MsgDashCount = 78

GLOBAL LogNum%                '  File Number of the LogFile          - Debug
GLOBAL Msg$                                                       '  - Debug


'  =============================================================================
'           StartLog%, WriteLogRecord & EndLog    - Debug
'  =============================================================================

'  A Function and two Subs used to Open a file, write logging records and close
'  the file used for storing Debug log messages.   -  Debug

'  These three procedures can be removed, along with their definitions and calls 
'  to them located throughout the source code.  They are left here so new 
'  PBWin developers have a simple way of generating information from the source
'  code they enter.  They are also a good way to understand how TradeStation is
'  working with the DLL program.  If you don't need this type of utility, don't 
'  be afraid to remove everything with a DEBUG line, or anything else you don't 
'  need
'  ....................

FUNCTION StartLog%(LogFile$)                                   '  - Debug
   
   LogNum% = FREEFILE                   '  Log File DOS Handle #  - Debug    
   OPEN LogFile$ FOR OUTPUT AS #LogNum% '  Open OR Create a File  - Debug
      
   PRINT #LogNum%, " "                                         '  - Debug
   PRINT #LogNum%, STRING$(78, "=")                            '  - Debug
   PRINT #LogNum%, "Log File OPENED @ ";DATE$;" - ";TIME$      '  - Debug
   PRINT #LogNum%, ""                                          '  - Debug
                                                               
   StartLog% = LogNum%                    '  Return the Logging file's handle
END FUNCTION   '  StartLog%                                    '  - Debug

'  ....................
'  Writes a one line Log message
SUB WriteLog( LogRecord$)                                      '  - Debug
         
   PRINT #LogNum%, "-> ";LogRecord$                            '  - Debug
   
END SUB  '  WriteLog                                           '  - Debug

'  ....................
'  Used to close the Log file
SUB EndLog                                                     '  - Debug
               
   PRINT #LogNum%, " "                                         '  - Debug
   PRINT #LogNum%, STRING$(%MsgDashCount, "-")                            '  - Debug
   PRINT #LogNum%, "Log File Closed @ ";DATE$;" - ";TIME$      '  - Debug
   PRINT #LogNum%, ""                                          '  - Debug
   PRINT #LogNum%, STRING$(%MsgDashCount, "=")                            '  - Debug
   
   CLOSE #LogNum%                         '  Close this File   '  - Debug
END SUB  '  EndLog


'  ....................
'  Fast File Open - Send Message process to create a popup text messages

SUB SendFastMsg( TextStringMsg AS STRING, CallingProcessName AS STRING )
   DIM FilNum AS LONG
   
   FilNum = FREEFILE                        '  Log File DOS Handle # 
   OPEN "C:\ErrMsg.Txt" FOR OUTPUT AS #FilNum '  Open OR Create a File  
      
   PRINT #FilNum, " "             
   PRINT #FilNum, STRING$(%MsgDashCount, "=")
   PRINT #FilNum, "Fast Message from: "; CallingProcessName;" - ";TIME$
   PRINT #FilNum, ""              
   PRINT #FilNum, "-> ";TextStringMsg
   PRINT #FilNum, ""                         
   PRINT #FilNum, STRING$(%MsgDashCount, "=")
   
   CLOSE #FilNum                         '  Close this File

   FilNum = SHELL("NotePad.EXE C:\ErrMsg.Txt", 1)

END SUB

'  =============================================================================
'                                END of DLL SOURCE CODE
'  =============================================================================
